#!/usr/bin/python

import os
import sys

# Function definition
def ch_ext(filename, tg_suffix):
    #This feature is only available after '.'
    #str_list = filename.rpartition('.')
    #res = str_list[0]+'.'+tg_suffix

    str_list = filename.split('.')
    str_list = str_list[0:len(str_list)-1]
    res = '.'.join(str_list) + '.'+tg_suffix
    return res

def do_computation(cmd):
    if (sys.argv[2] == 'comp'):
        print 'exec ',cmd
        os.system(cmd)
    elif (sys.argv[2] == 'cmd'):
        print cmd


def do_figures(cmd):
    if (sys.argv[2] == 'fig'):
        print 'exec ',cmd
        os.system(cmd)
    elif (sys.argv[2] == 'cmd'):
        print cmd


#clip1 = 'newclip=1 eclip=2.5 bclip=-2.5'
clip2 = ' newclip=1 wantscalebar=y '
clip  = clip2
#Some env varaibles
M = '.'
B = 'bin'
O = 'scr'

data = M + '/data-syn-decon.H'
exe = B+'/Sparse_decon.x'
labelsz = ' ' # 'labelsz=9'

# 1. Tune l2 parameters, only one parameter, epsilon
#eps_l2 = ['1e-9', '1e-6', '1e-3', '0.01', '0.1', '1.0', '10.0', '100.0', '1000.0']
eps_l2 = ['0.001','0.01','0.1','1.0','10.0']
#eps_l2 = ['10.0']
#eps_l2 = ['1e-9','1e-6','1e-3','1','1000','1e6']

#Display the filter as well
n = len(eps_l2)
wavelet = M + '/wavelet-syn.H'

figlist = []

if sys.argv[1] == '1' :
    for i in range(0,n):
        eps = eps_l2[i]
        output = O+'/decon_l2_'+eps+'.H'
        d_a = 'l2_d_a_'+eps+'.H'
        resd = 'l2_resd_'+eps+'.H'
        resm = 'l2_resm_'+eps+'.H'
        filt_out = 'l2_filt_out_'+eps+'.H'
        make_cmd = '< ' + data + ' '+ exe + ' ' + 'inv=1' + ' ' +\
				   'par=par/syn_decon_par_l2.P' +' ' +'eps=' + eps + ' ' +\
				   'filt=decon_l2_filt_' + eps + '.H' + ' ' + '> ' +\
				   output + ' ' +'d_a='+d_a + ' ' + 'resd='+resd + ' '\
				    + 'resm='+resm + ' ' + 'wavelet='+wavelet + ' ' + \
					'filt_out='+filt_out
        print make_cmd
		
    #Run the command
        #os.system('pause')
        do_computation(make_cmd)
#Display the output result
        
        fig = 'decon_l2_'+eps+'.v'
        disp_cmd = '< '+output + ' ' +  'Grey  ' + clip + '   title='+\
				   output +' ' + '>/dev/null' + ' ' + 'out='+fig + ' '\
				   + labelsz
        do_figures(disp_cmd)
        disp_cmd = 'tube ' + fig + ' &'
        #os.system(disp_cmd)

        fig2 = 'l2_d_a_'+eps+'.v'
        disp_cmd = '< '+d_a + ' ' +  'Grey  ' + clip + '   title='\
				   +d_a +' ' +  '>/dev/null' + ' ' + 'out='+fig2 + ' '\
				   + labelsz
        do_figures(disp_cmd)
        disp_cmd = 'tube ' + fig2 + ' &'
       	#os.system(disp_cmd)

        fig3 = 'l2_resd_'+eps+'.v'
        disp_cmd = '< '+resd + ' ' +  'Grey  ' + clip + '   title='\
				   +resd +' ' + 'out='+fig3 + ' ' +'>/dev/null' + ' ' \
				   + labelsz
        do_figures(disp_cmd)
        disp_cmd = 'tube ' + fig3 + ' &'
        #os.system(disp_cmd)
		
		#Display the Dots graph of filt_out
        fig4 = 'l2_filt_out_'+eps+'.v'
        disp_cmd = '< '+filt_out + ' ' + "Graph label1='Samples' label2='Amp'"\
				   + ' ' + 'title=wavelet*filter' + ' ' +' >/dev/null '\
				   + 'out='+fig4 + ' ' + labelsz
        do_figures(disp_cmd)
        disp_cmd = 'tube ' + fig4 + ' &'
        #os.system(disp_cmd)

        fig_f = 'Fig/decon_l2_'+eps+'.v'
        #fig_cmd = 'vppen '+fig+ ' ' + fig2 + ' ' + fig3 + ' ' + fig4 + ' '\
	#			  '> ' + fig_f  + ' ' \
	#			  + 'size=r vpstyle=n  gridnum=2,2'
        fig_cmd = 'vppen '+fig + ' ' + fig4 + ' '\
				  '> ' + fig_f  + ' ' \
				  + 'size=r vpstyle=n  gridnum=2,1'

        do_figures(fig_cmd)
        disp_cmd = 'tube ' + fig_f + ' &'
        #os.system(disp_cmd)
        figlist.append(fig_f)
        
    cmd = 'vp_Movie ' + ' '.join(figlist) + ' ' +'> ' + 'Fig/decon_l2_final.v'
    #print cmd
    do_figures(cmd)
    cmd = 'tube Fig/decon_l2_final.v &'
    do_figures(cmd)
    
		
# 2. Tune l1 parameters, let L2 applied to Rd, and L1 applied to Rm. 
#eps_hb = ['1e-9', '1e-6', '1e-3', '0.01', '0.1', '1.0', '10.0', '100.0', '1000.0']
eps_hb = ['0.1']
#eps_hb = ['0.5', '0.8', '1.0']
#eps_hb = ['0.1', '0.2', '0.3','0.4']
#eps_hb = ['3.0','2.0','1.0','0.8','0.6','0.5']

#Rm = '0.53'  #Refl 95 percentile
#Rm = '0.1'
#Rm = '0.95'

qnt_hb = ['0.8'] # ,'0.9','0.95']
qntm = qnt_hb[0]
Rm = qntm

#Display the filter as well
n = len(eps_hb)

if sys.argv[1] == '2' :
    for i in range(0,n):
        eps = eps_hb[i]
        suffix = eps + '_' +'Rm_'+Rm
        output = O+'/decon_hb_'+suffix+'.H'
        d_a = 'hb_d_a_'+suffix+'.H'
        resd = 'hb_resd_'+suffix+'.H'
        resm = 'hb_resm_'+suffix+'.H'
        filt_out = 'hb_filt_out_'+suffix+'.H'
        #rthm = 'r_th_m_in='+'0.01' + ' '            
        rthm = 'qnt_m='+qntm + ' ' 
        make_cmd = '< ' + data + ' '+ exe + ' ' + 'inv=1' + ' ' +\
            'par=par/syn_decon_par_hb.P' +' ' +'eps=' + eps + ' ' +\
            rthm +\
            'filt=decon_hb_filt_' + suffix + '.H' + ' ' + '> ' +\
            output + ' ' +'d_a='+d_a + ' ' + 'resd='+resd + ' '\
            + 'resm='+resm + ' ' + 'wavelet='+wavelet + ' ' + \
            'filt_out='+filt_out + ' & '
        
	do_computation(make_cmd)	
        #Run the command


#Display the output result
        
        fig = 'decon_hb_'+suffix+'.v'
        disp_cmd = '< '+output + ' ' +  'Grey' + ' ' + clip2 + ' ' + 'color=IC wantscalebar=y title='+\
				   output +' ' + '>/dev/null' + ' ' + 'out='+fig + ' '\
				   + labelsz
        do_figures(disp_cmd)
        #print disp_cmd
        disp_cmd = 'tube ' + fig + ' &'
        #do_figures(disp_cmd)
        
        fig2 = 'hb_d_a_'+suffix+'.v'
        disp_cmd = '< '+d_a + ' ' +  'Grey' + ' ' + clip2 + ' ' + 'color=IC wantscalebar=y title='\
				   +d_a +' ' +  '>/dev/null' + ' ' + 'out='+fig2 + ' '\
				   + labelsz
        do_figures(disp_cmd)
        disp_cmd = 'tube ' + fig2 + ' &'
       	#do_figures(disp_cmd)

        fig3 = 'hb_resd_'+suffix+'.v'
        disp_cmd = '< '+resd + ' ' +  'Grey' + ' ' + clip2 + ' ' + 'color=IC wantscalebar=y title='\
				   +resd +' ' + 'out='+fig3 + ' ' +'>/dev/null' + ' ' \
				   + labelsz
        do_figures(disp_cmd)
        disp_cmd = 'tube ' + fig3 + ' &'
        #do_figures(disp_cmd)
		
		#Display the Dots graph of filt_out
        fig4 = 'hb_filt_out_'+suffix+'.v'
        disp_cmd = '< '+filt_out + ' ' + "Dots label1='Samples' label2='Amp'"\
				   + ' ' + 'title=wavelet*filter' + ' ' +' >/dev/null '\
				   + 'out='+fig4 + ' ' + labelsz
        do_figures(disp_cmd)
        disp_cmd = 'tube ' + fig4 + ' &'
        #do_figures(disp_cmd)

        fig_f = 'fig/decon_hb_'+suffix+'.v'
        fig_cmd = 'vppen '+fig+ ' ' + fig2 + ' ' + fig3 + ' ' + fig4 + ' '\
				  '> ' + fig_f  + ' ' \
				  + 'size=r vpstyle=n  gridnum=2,2'
        #fig_cmd = 'vppen '+fig+ ' ' + ' ' + ' ' + fig4 + ' '\
	#			  '> ' + fig_f  + ' ' \
	#			  + 'size=r vpstyle=n  gridnum=1,2'
        do_figures(fig_cmd)
        do_figures(fig_cmd)
        disp_cmd = 'tube ' + fig_f + ' &'
        #do_figures(disp_cmd)
        
        figlist.append(fig_f)
    #Add the figures to Movie
    cmd = 'vp_Movie ' + ' '.join(figlist) + ' ' +'> ' + 'fig/decon_hb_final.v'
    print cmd
    do_figures(cmd)
    cmd = 'tube fig/decon_hb_final.v &'
    do_figures(cmd)


#Plot the movie of overlapping best L2 result, L1 result and refl model
if (sys.argv[1] == '3'):

    figlist = []
    fig = 'decon_hb_1_Rm_0.1.v'
    input = 'Res/decon_hb_1_Rm_0.1.H'
    disp_cmd = '< '+input + ' ' +  'Grey' + ' ' + clip2 + ' ' + 'color=IC  title='+\
				   input +' ' + '>/dev/null' + ' ' + 'out='+fig + ' '\
				   + labelsz + ' ' + 'wantscalebar=1'
    do_figures(disp_cmd)
    figlist.append(fig)

    fig = 'decon_l2_1.v'
    input = 'Res/decon_l2_1.0.H'
    disp_cmd = '< '+input + ' ' +   'Grey' + ' ' + clip2 + ' ' + 'color=IC  title='+\
				   input +' ' + '>/dev/null' + ' ' + 'out='+fig + ' '\
				   + labelsz + ' ' + 'wantscalebar=1'
    do_figures(disp_cmd)
    figlist.append(fig)

    input = M+'/refl.H'
    fig = 'refl.v'
    disp_cmd = '< '+input + ' ' +  'Grey' + ' ' + clip2 + ' ' + ' color=IC  title='+\
				   input +' ' + '>/dev/null' + ' ' + 'out='+fig + ' '\
				   + labelsz + ' ' + 'wantscalebar=1'
    do_figures(disp_cmd)
    figlist.append(fig)

    
    cmd = 'vp_Movie ' + ' '.join(figlist) + ' ' +'> ' + 'comp_hb_refl.v'
    do_figures(cmd)
    disp_cmd = 'tube ' + 'comp_hb_refl.v &'
    do_figures(disp_cmd)


data = 'data-COF.H'

if sys.argv[1] == '5' :
    #  Hybrid Decon on GEE Common offset gather data . Tune l1 parameters, let L2 applied to Rd, and L1 applied to Rm.
    #  Search both the Epsilon and Quantile
    eps_hb = ['0.1'] #,'0.3','0.5','0.7','0.9']# '1.0']#,\
              #'3.162','10.0','31.62', '100.0']
    #eps_hb = [ '4','5','6','7','8','9']
    qnt_hb = ['0.8'] #,'0.9']
    #qnt_hb = ['0.9']

    tag_str='COF-'

    # We might need to run qntm with the Arbitrary value again.

    #Rm = '10' #
    G = '.'
    n_eps = len(eps_hb)
    n_qntm = len(qnt_hb)

    parname='par/par_decon_gee_coffset.P'

#   Display the original data
    fig2 = 'cof_data.v'
    disp_cmd = '< ' + data + ' ' +  'Grey' + ' ' + clip2 + ' ' + '  wantscalebar=1 title='+\
				   data +' ' + '>/dev/null' + ' ' + 'out='+fig2 + ' '\
				   + labelsz
    do_figures(disp_cmd)
    disp_cmd = 'tube '+fig2 + ' &'
    do_figures(disp_cmd)

    figlist = []
    output_list_qntm = []
    for ind_qntm in range(0,n_qntm):
        qntm = qnt_hb[ind_qntm]

        output_list = []
        for ind_eps in range(0, n_eps):
            eps = eps_hb[ind_eps]
            suffix = tag_str+eps + '-qntm-'+qntm
            output = O+'/decon_hb_'+suffix+'.H'
            d_a =  O+'/hb_d_a_'+suffix+'.H'
            resd = O+'/hb_resd_'+suffix+'.H'
            #resm = O+'/hb_resm_'+suffix+'.H'
            filt = O+'/hb_gee3_hb_filt_' + suffix + '.H'
            #filt_out = O + '/hb_filt_out_'+suffix+'.H'

            #str_alpha = str(alpha)
            make_cmd = '< ' + data + ' '+ exe + ' ' + 'inv=1' + ' ' +\
                       'par='+parname + ' ' +'eps=' + eps + ' ' +\
                       'qnt_m='+qntm + \
                       ' ' + 'filt='+filt + ' ' + '> ' +\
                       output + ' ' +'d_a='+d_a + ' ' + 'resd='+resd + ' '\
                       + '  & '
#Run the Inversion program
            do_computation(make_cmd)
            
            output_list.append(output)
            
#Display the output result
            fig = O+'/decon-hb-'+suffix+'.v'
            disp_cmd = '< '+output + ' ' +  'Grey' + ' ' + clip2 + ' ' + '  wantscalebar=1 title='+\
				   output +' ' + '>/dev/null' + ' ' + 'out='+fig + ' '\
				   + labelsz
            do_figures(disp_cmd)
            disp_cmd = 'tube ' + fig + ' &'
            #os.system(disp_cmd)
        
            fig2 = O+'/hb_d_a_'+suffix+'.v'
            disp_cmd = '< '+d_a + ' ' +  'Grey' + ' ' + clip2 + ' ' + '  wantscalebar=y title='\
				   +d_a +' ' +  '>/dev/null' + ' ' + 'out='+fig2 + ' '\
				   + labelsz
            do_figures(disp_cmd)
            disp_cmd = 'tube ' + fig2 + ' &'
       	    #os.system(disp_cmd)
            fig3 = O+'/hb_resd_'+suffix+'.v'
            disp_cmd = '< '+resd + ' ' +  'Grey' + ' ' + clip2 + ' ' + '  wantscalebar=y title='\
				   +resd +' ' + 'out='+fig3 + ' ' +'>/dev/null' + ' ' \
				   + labelsz
            do_figures(disp_cmd)
            disp_cmd = 'tube ' + fig3 + ' &'
            #os.system(disp_cmd)
		
            #Display the Dots graph of filt_out
            fig4 = O+'/hb_filt_out_'+suffix+'.v'
            disp_cmd = '< '+filt + ' ' + "Dots label1='Samples' label2='Amp'"\
                       + ' ' + 'title=filter' + ' ' +' >/dev/null '\
                       + 'out='+fig4 + ' ' + labelsz
            do_figures(disp_cmd)
            disp_cmd = 'tube ' + fig4 + ' &'
            #os.system(disp_cmd)

            fig_f = '../decon_hb_gee3_'+suffix+'.v'
            fig_cmd = 'vppen '+fig+ ' ' + fig2 + ' ' + fig3 + ' ' + fig4 + ' '\
                      '> ' + fig_f  + ' ' \
                      + 'size=r vpstyle=n  gridnum=2,2'
            do_figures(fig_cmd)
            figlist.append(fig_f)
            #figlist.append(fig)
            #end for eps loop
        #Cat the files for different eps
        fn = O + '/hb-m-qntm-' + qntm  + tag_str+'.H'
        cat_cmd = 'Cat3d ' + ' '.join(output_list) \
                  + ' axis=3 ' + ' > ' + fn
        #do_figures(cat_cmd)

        output_list_qntm.append(fn);
        #end for qntm loop

    #Cat the qntm .H files into the 4D Cube
    fn = G + '/hb-m-qntm'+tag_str+'.H'
    cat_cmd = 'Cat3d ' + ' '.join(output_list_qntm) \
                  + ' axis=4 ' + ' > ' + fn
    #do_figures(cat_cmd)

    #setup the axis information
    cmd = 'echo o3=-3' +  ' >> ' + fn  # eps_min = 10^(-3)
    #do_figures(cmd)
    cmd = 'echo d3=0.5' + ' >> ' + fn
    #do_figures(cmd)
    cmd = 'echo label3=eps' + ' >> ' + fn
    #do_figures(cmd)
    cmd = 'echo label1=\'time(sec)\'' + ' >> ' + fn
    #do_figures(cmd)

    cmd = 'echo o4=0.1' + ' >> ' + fn  # qntm_min=0.1, e.g 10%
    #do_figures(cmd)
    cmd = 'echo d4=0.1' + ' >> ' + fn  
    #do_figures(cmd)
    cmd = 'echo label4=qntm' + ' >> ' + fn
    #do_figures(cmd)

    #Add the figures to Movie, This Movie should contain n_eps*n_qntm files
    final_fig_name = 'decon_hb_qntm_gee3_final'+tag_str+'.v3'
    cmd = 'vp_Movie ' + ' '.join(figlist) + ' ' +'> ' + final_fig_name
    do_figures(cmd)
    cmd = 'tube ' + final_fig_name + ' &'
    do_figures(cmd)


#2 step least squares decon with manually extracted wavelet on COF data
pclip = ' gainpanel=e pclip=99 wantscalebar=1'

if sys.argv[1] == '6' :
    eps_m_hb = ['0.01']
    eps_a = '0.0001'
    qntm_hb = ['0.8'] #'0.9']
    
    n_eps = len(eps_m_hb)
    n_qntm = len(qntm_hb)
    
    niter_nl  = 1
    niter_lin = 200

    #data = './data-COF.H'
    exe = B+'/Sp_decon_2_ls.x'

    #Use common decon result as initial model and wavelet
    #wavelet_init = './wavelet_init.H'
    wavelet_init = './data/decon/wavelet-COF.HH'
    #wavelet_init = './wavelet_init-COF.H'
    #wavelet_init = '../data/l2_wavelet.HH'
    #model_init = './model_init.H'
    #wavelet_init = '../data/l2_wavelet.HH'
    #model_init = './refl.H'

    figlist=[]
  
    tag_str = 'COF-'
    for ind_qntm in range(0,n_qntm):
        qntm = qntm_hb[ind_qntm]
        output_list = []

        for ind_eps in range(0, n_eps):
            eps_m = eps_m_hb[ind_eps]

            suffix = tag_str+'qntm-'+qntm+'-epsm-'+eps_m
            output = O+'/decon-hb-'+suffix+'.H'
            resd = O+'/hb-resd-'+suffix+'.H'
            filter = O+'/hb-filter-'+suffix+'.H'
            
            make_cmd = '< ' + data + ' '+ exe + ' ' + \
                ' max_overshot_shrink_cnt=5 norm_mod=hybrid norm_dat=l2 qt_period=5 ' +' ' +'eps_m=' + eps_m + ' ' + 'eps_a=' + eps_a + ' wavelet_init='+wavelet_init + ' ' + \
                'qnt_m='+qntm + ' '  + ' ' + 'wavelet='+filter + ' ' + 'niter_nl='+str(niter_nl) + ' niter_lin='+str(niter_lin) + ' > ' + output + \
                ' ' + 'resd='+resd + ' zero_lag=0' + ' '# + ' model_init='+model_init #
            
            #r_th_m=0.02
            #The file wavelet, output and resd contains multiple frames (for each non-linear iteration)
            
            #Run the command
            do_computation(make_cmd)
            output_list.append(output)

            #Display the output result
            fig = ch_ext(output,'v')    #The change of output model
            disp_cmd = '< '+output + ' ' +   'Grey '+ pclip + ' title='+\
                output +' ' + '>/dev/null' + ' ' + 'out='+fig + ' '\
                + labelsz
            do_figures(disp_cmd)
            disp_cmd = 'tube ' + fig + ' &'
            do_figures(disp_cmd)

            #fig2 = ch_ext(res_causint,'v')
            fig2 = ch_ext(filter,'v')   #The change of wavelet
            disp_cmd = '< '+ filter + ' Transp plane=23 | ' +  ' Graph ' + ' title='+\
                filter +' ' +  '>/dev/null' + ' ' + 'out='+fig2 + ' '\
                + labelsz
            do_figures(disp_cmd)
            disp_cmd = 'tube ' + fig2 + ' &'
            do_figures(disp_cmd)

            fig3 = ch_ext(resd,'v')     #The change of data-residue in inversion, notice it is DIFF from data fitting error
            disp_cmd = '< '+resd + ' ' +   'Grey '+ pclip + ' title='+\
                                       resd +' ' + 'out='+fig3 + ' ' +'>/dev/null' + ' ' \
                                       + labelsz
            do_figures(disp_cmd)
            disp_cmd = 'tube ' + fig3 + ' &'
            do_figures(disp_cmd)
            
            fig4 = 'data.v'
            disp_cmd = '< ' + data + ' ' +   'Grey '+ pclip + ' title='+\
                resd +' ' + 'out='+fig4 + ' ' +'>/dev/null' + ' ' + labelsz
            do_figures(disp_cmd)
            disp_cmd = 'tube ' + fig4 + ' &'
            do_figures(disp_cmd)

            fig_f = 'fig-hb-'+suffix+'.v'
            fig_cmd = 'vppen '+fig+ ' ' + fig2 + ' ' + fig3 + ' ' + fig4 + ' '\
                                      '> ' + fig_f  + ' ' \
                                      + 'size=r vpstyle=n  gridnum=2,2'

            #do_figures(fig_cmd)
            #disp_cmd = 'tube ' + fig_f + ' &'
            #do_figures(disp_cmd)
            figlist.append(fig_f)
    
    #Add the figures to Movie, This Movie should contain n_eps*n_Rm files
    final_fig_name = 'decon_hb_COF-qntm-'+tag_str+'.v3'
    cmd = 'vp_Movie ' + ' '.join(figlist) + ' ' +'> ' + final_fig_name
    #do_figures(cmd)
    cmd = 'tube ' + final_fig_name + ' &'
    #do_figures(cmd)

#7 non-linear decon with lag spike as the initial wavelet
pclip = ' gainpanel=e pclip=99 wantscalebar=1'

if sys.argv[1] == '7' :
    eps_m_hb = ['0.01']
    eps_a = '0.1'
    qntm_hb = ['0.8'] #'0.9']
    
    n_eps = len(eps_m_hb)
    n_qntm = len(qntm_hb)
    
    niter_nl  = 500
    niter_lin = 3

    data = './data-COF.H'
    exe = B+'/Sparse_decon_nl.x'

    #Use common decon result as initial model and wavelet
    #wavelet_init = './wavelet_init.H'
    wavelet_init = './data/decon/wavelet-COF.HH'
    #wavelet_init = './wavelet_init-COF.H'
    #wavelet_init = '../data/l2_wavelet.HH'
    #model_init = './model_init.H'
    #wavelet_init = '../data/l2_wavelet.HH'
    #model_init = './refl.H'

    figlist=[]
  
    tag_str = 'COF-'
    for ind_qntm in range(0,n_qntm):
        qntm = qntm_hb[ind_qntm]
        output_list = []

        for ind_eps in range(0, n_eps):
            eps_m = eps_m_hb[ind_eps]

            suffix = tag_str+'qntm-'+qntm+'-epsm-'+eps_m
            output = O+'/decon-hb-'+suffix+'.H'
            resd = O+'/hb-resd-'+suffix+'.H'
            d_error = O+'/hb-derror-'+suffix+'.H'
            filter = O+'/hb-filter-'+suffix+'.H'
            
            make_cmd = '< ' + data + ' '+ exe + ' ' + \
                ' max_overshot_shrink_cnt=5 norm_mod=hybrid norm_dat=l2 qt_period=5 ' +' ' +'eps_m=' + eps_m + ' ' + 'eps_a=' + eps_a + ' wavelet_init='+wavelet_init + ' ' + 'alpha=0.01 ' +\
                'qnt_m='+qntm + ' '  + ' ' + 'wavelet='+filter + ' ' + 'niter_nl='+str(niter_nl) + ' niter_lin='+str(niter_lin) + ' > ' + output + \
                ' ' + 'd_error='+d_error + ' zero_lag=7' + ' '# + ' model_init='+model_init #
             
            #r_th_m=0.02
            #The file wavelet, output and resd contains multiple frames (for each non-linear iteration)
            
            #Run the command
            do_computation(make_cmd)
            output_list.append(output)

            #Display the output result
            fig = ch_ext(output,'v')    #The change of output model
            disp_cmd = '< '+output + ' ' +   'Grey '+ pclip + ' title='+\
                output +' ' + '>/dev/null' + ' ' + 'out='+fig + ' '\
                + labelsz
            do_figures(disp_cmd)
            disp_cmd = 'tube ' + fig + ' &'
            do_figures(disp_cmd)

            #fig2 = ch_ext(res_causint,'v')
            fig2 = ch_ext(filter,'v')   #The change of wavelet
            disp_cmd = '< '+ filter + ' Transp plane=23 | ' +  ' Graph ' + ' title='+\
                filter +' ' +  '>/dev/null' + ' ' + 'out='+fig2 + ' '\
                + labelsz
            do_figures(disp_cmd)
            disp_cmd = 'tube ' + fig2 + ' &'
            do_figures(disp_cmd)

            fig3 = ch_ext(d_error,'v')     #The change of data-residue in inversion, notice it is DIFF from data fitting error
            disp_cmd = '< '+d_error + ' ' +   'Grey '+ pclip + ' title='+\
                                       d_error +' ' + 'out='+fig3 + ' ' +'>/dev/null' + ' ' \
                                       + labelsz
            do_figures(disp_cmd)
            disp_cmd = 'tube ' + fig3 + ' &'
            do_figures(disp_cmd)
            
            fig4 = 'data.v'
            disp_cmd = '< ' + data + ' ' +   'Grey '+ pclip + ' title='+\
                data +' ' + 'out='+fig4 + ' ' +'>/dev/null' + ' ' + labelsz
            do_figures(disp_cmd)
            disp_cmd = 'tube ' + fig4 + ' &'
            do_figures(disp_cmd)

            fig_f = 'fig-hb-'+suffix+'.v'
            fig_cmd = 'vppen '+fig+ ' ' + fig2 + ' ' + fig3 + ' ' + fig4 + ' '\
                                      '> ' + fig_f  + ' ' \
                                      + 'size=r vpstyle=n  gridnum=2,2'

            #do_figures(fig_cmd)
            #disp_cmd = 'tube ' + fig_f + ' &'
            #do_figures(disp_cmd)
            figlist.append(fig_f)
    
    #Add the figures to Movie, This Movie should contain n_eps*n_Rm files
    final_fig_name = 'decon_hb_COF-qntm-'+tag_str+'.v3'
    cmd = 'vp_Movie ' + ' '.join(figlist) + ' ' +'> ' + final_fig_name
    #do_figures(cmd)
    cmd = 'tube ' + final_fig_name + ' &'
    #do_figures(cmd)



######################### 2 step ls inversion by gradually increasing the filter length  #########
if sys.argv[1] == '8' :
    eps_m_hb = ['0.01']
    eps_a = '0.1'
    qntm_hb = ['0.8'] #'0.9']
    
    n_eps = len(eps_m_hb)
    n_qntm = len(qntm_hb)
    
    niter_nl  = 100
    niter_lin = 5

    data = './data-COF.H'
    exe = B+'/Sp_decon_grad.x'

    #Use common decon result as initial model and wavelet
    #wavelet_init = './wavelet_init.H'
    wavelet_init = './data/decon/wavelet-COF.HH'
    #wavelet_init = './wavelet_init-COF.H'
    #wavelet_init = '../data/l2_wavelet.HH'
    #model_init = './model_init.H'
    #wavelet_init = '../data/l2_wavelet.HH'
    #model_init = './refl.H'

    figlist=[]
  
    tag_str = 'COF-grad-'
    for ind_qntm in range(0,n_qntm):
        qntm = qntm_hb[ind_qntm]
        output_list = []

        for ind_eps in range(0, n_eps):
            eps_m = eps_m_hb[ind_eps]

            suffix = tag_str+'qntm-'+qntm+'-epsm-'+eps_m
            output = O+'/decon-hb-'+suffix+'.H'
            resd = O+'/hb-resd-'+suffix+'.H'
            d_error = O+'/hb-derror-'+suffix+'.H'
            filter = O+'/hb-filter-'+suffix+'.H'
            
            make_cmd = '< ' + data + ' '+ exe + ' ' + \
                ' max_overshot_shrink_cnt=5 norm_mod=hybrid norm_dat=l2 qt_period=5 ' +' ' +'eps_m=' + eps_m + ' ' + 'eps_a=' + eps_a + ' wavelet_init='+wavelet_init + ' ' + 'alpha=0.01 ' +\
                'qnt_m='+qntm + ' '  + ' ' + 'wavelet='+filter + ' ' + 'niter_nl='+str(niter_nl) + ' niter_lin='+str(niter_lin) + ' > ' + output + \
                ' ' + 'd_error='+d_error + ' zero_lag=7' + ' '# + ' model_init='+model_init #
             
            #r_th_m=0.02
            #The file wavelet, output and resd contains multiple frames (for each non-linear iteration)
            
            #Run the command
            do_computation(make_cmd)
            output_list.append(output)

            #Display the output result
            fig = ch_ext(output,'v')    #The change of output model
            disp_cmd = '< '+output + ' ' +   'Grey '+ pclip + ' title='+\
                output +' ' + '>/dev/null' + ' ' + 'out='+fig + ' '\
                + labelsz
            do_figures(disp_cmd)
            disp_cmd = 'tube ' + fig + ' &'
            do_figures(disp_cmd)

            fig2 = ch_ext(filter,'v')   #The change of wavelet
            disp_cmd = '< '+ filter + ' Transp plane=23 | ' +  ' Graph min2=-0.5 max2=1.2 ' + ' title='+\
                filter +' ' +  '>/dev/null' + ' ' + 'out='+fig2 + ' '\
                + labelsz
            do_figures(disp_cmd)
            disp_cmd = 'tube ' + fig2 + ' &'
            do_figures(disp_cmd)

            
            fig4 = 'data.v'
            disp_cmd = '< ' + data + ' ' +   'Grey '+ pclip + ' title='+\
                data +' ' + 'out='+fig4 + ' ' +'>/dev/null' + ' ' + labelsz
            do_figures(disp_cmd)
            disp_cmd = 'tube ' + fig4 + ' &'
            do_figures(disp_cmd)

            fig_f = 'fig-hb-'+suffix+'.v'
            fig_cmd = 'vppen '+fig+ ' ' + fig2 + ' ' + ' ' + fig4 + ' '\
                                      '> ' + fig_f  + ' ' \
                                      + 'size=r vpstyle=n  gridnum=2,2'

            #do_figures(fig_cmd)
            #disp_cmd = 'tube ' + fig_f + ' &'
            #do_figures(disp_cmd)
            figlist.append(fig_f)
    
    #Add the figures to Movie, This Movie should contain n_eps*n_Rm files
    final_fig_name = 'decon_hb_COF-qntm-'+tag_str+'.v3'
    cmd = 'vp_Movie ' + ' '.join(figlist) + ' ' +'> ' + final_fig_name
    #do_figures(cmd)
    cmd = 'tube ' + final_fig_name + ' &'
    #do_figures(cmd)
