#!/usr/bin/python

import os
import sys



# Function definition
def ch_ext(filename, tg_suffix):
    #This feature is only available after '.'
    #str_list = filename.rpartition('.')
    #res = str_list[0]+'.'+tg_suffix

    str_list = filename.split('.')
    str_list = str_list[0:len(str_list)-1]
    res = '.'.join(str_list) + '.'+tg_suffix
    return res

def do_computation(cmd):
    if (sys.argv[2] == 'comp'):
        print 'exec ',cmd
        os.system(cmd)

def do_figures(cmd):
    if (sys.argv[2] == 'fig'):
        print 'exec ',cmd
        os.system(cmd)


label = 'label1="depth [kft]" label2="distance [kft]" label3=" " '

hess = 'hess.H' #'wem.sigsb2a.hess.random.fsec.all.lab.H' X 1000
data = 'sigsb2a.syn.imag.H' # 'wem.sigsb2a.syn.data.lab.H' its amplitude will be normalized in the program
mask = 'sigsb2a.mask.H'

#clip = ' pclip=99 wantscalebar=1 '
clip = ' newclip=1 wantscalebar=1 '
niter = '100'
qt_period = '5'


if (sys.argv[1] == '1'):
    B = 'bin'
    exe = B+'/Hesconv_hb.x'

    qntm_hb = ['0.6', '0.8','0.9', '1.0']
    #eps_hb  = ['1e-7', '1e-6', '1e-5', '1e-4', '1e-3', '1e-2', '1e-1']
    eps_hb = [ '2e-4' ]

    reg = '1'  # Damping regularization

    #${BINDIR}/hesconv.x adj=y imgsign=1 data=wem.sigsb2a.syn.data.lab.H modl=$@ hess=wem.sigsb2a.hess.random.fsec.all.lab.H \
    #         mask=wem.sigsb2a.mask.lab.H mmov=wem.sigsb2a.syn.inv.mmov.lab.H rmov=wem.sigsb2a.syn.inv.rmov.lab.H niter=50 eps=0.0002 reglar=2

    O = './scr'
 
    n_qntm = len(qntm_hb)
    n_eps  = len(eps_hb)

    reg='1'
    tag_str='damp-'

    figlist=[]
    for ind_qntm in range(0,n_qntm):
        qntm = qntm_hb[ind_qntm]
        for ind_eps in range(0, n_eps):
            eps = eps_hb[ind_eps]
            
            output_list = []
            suffix = tag_str+'qntm-'+qntm+'-eps-'+eps
            output = O+'/syn-inv-'+suffix+'.H'
            
            recov_d = O+'/recov-'+suffix+'.H'
            resd = O +'/resd-'+suffix+'.H'

            #Call the cmd
            make_cmd = exe + ' adj=y imgsign=1 ' + 'data='+data + ' modl='+output + ' hess='+hess \
                + ' mask='+mask + ' niter='+niter + ' eps='+eps + ' qntm='+qntm + ' reglar='+reg + ' ' + ' norm_dat=l2 norm_mod=hybrid ' + ' resd='+resd + ' qt_period='+qt_period #+ ' & '

            do_computation(make_cmd)
            
            #Do the forward modeling Hm, to see how much it matches the data
            cmd = exe + ' adj=n ' + ' data='+recov_d + ' modl='+output + ' hess='+hess 
            do_figures(cmd)

            output_list.append(output)
            #Generate the figures
            fig = O+'/syn-inv-'+suffix+'.v'

            disp_cmd = '< '+output + ' Window3d | Add scale=-1 | Transp | ' +  'Grey' + '  '+clip + ' wantscalebar=1 title='+\
                output +' ' + '>/dev/null' + ' ' + 'out=inv_res.v' + ' '\
                + label
            do_figures(disp_cmd)

            #Input data
            disp_cmd = '< '+data + ' Window3d | Add scale=-1 | Transp | ' +  'Grey' + '  '+clip + ' wantscalebar=1 title='+\
                data +' ' + '>/dev/null' + ' ' + 'out=data.v' + ' '\
                + label
            do_figures(disp_cmd)
            
            disp_cmd = '< '+recov_d + ' Window3d | Add scale=-1 | Transp | ' +  'Grey' + '  '+clip + ' wantscalebar=1 title='+\
                recov_d +' ' + '>/dev/null' + ' ' + 'out=recov_d.v' + ' '\
                + label
            do_figures(disp_cmd)
            
            
            #data residue 
            disp_cmd = '< '+resd + ' Window3d | Add scale=-1 | Transp | ' +  'Grey' + '  '+clip + ' wantscalebar=1 title='+\
                resd +' ' + '>/dev/null' + ' ' + 'out=resd.v' + ' '\
                + label
            do_figures(disp_cmd)
            
            #disp_cmd = 'vp_SideBySideAniso ' + ' inv_res.v recov_d.v resd.v' + ' > ' + fig
            disp_cmd = 'vppen vpstyle=n gridnum=2,2 ' + ' data.v inv_res.v recov_d.v resd.v' + ' > ' + fig
            do_figures(disp_cmd)

            figlist.append(fig)
            
    #We form the movie
    final_fig_name = 'fig/syn-inv-qntm'+tag_str+'.v3'
    cmd = 'vp_Movie ' + ' '.join(figlist) + ' ' +'> ' + final_fig_name
    do_figures(cmd)
    cmd = 'tube ' + final_fig_name + ' &'
    do_figures(cmd)


# Hessian Inversion applying hb norm on model
if (sys.argv[1] == '2'):
    B = 'bin'
    exe = B+'/Hesconv_hb_Rm.x'  #The Executive is different 

    #Rm_hb = ['1','0.1','0.01','0.001']
    Rm_hb = ['0.01']
    #eps_hb  = ['1e-7', '1e-6', '1e-5', '1e-4', '1e-3', '1e-2', '1e-1']
    #eps_hb = ['2e-4','4e-4','6e-4','8e-4']
    eps_hb = ['1e-5','1e-4','2e-4', '4e-4','6e-4']

    reg = '1'  # Damping regularization

    #${BINDIR}/hesconv.x adj=y imgsign=1 data=wem.sigsb2a.syn.data.lab.H modl=$@ hess=wem.sigsb2a.hess.random.fsec.all.lab.H \
    #mask=wem.sigsb2a.mask.lab.H mmov=wem.sigsb2a.syn.inv.mmov.lab.H rmov=wem.sigsb2a.syn.inv.rmov.lab.H niter=50 eps=0.0002 reglar=2

    O = './scr'

    n_Rm = len(Rm_hb)
    n_eps  = len(eps_hb)

    reg='1'
    tag_str='damp-'

    figlist=[]
    for ind_Rm in range(0,n_Rm):
        Rm = Rm_hb[ind_Rm]
        for ind_eps in range(0, n_eps):
            eps = eps_hb[ind_eps]
            
            output_list = []
            suffix = tag_str+'Rm-'+Rm+'-eps-'+eps
            output = O+'/syn-inv-'+suffix+'.H'
            
            recov_d = O+'/recov-'+suffix+'.H'
            resd = O +'/resd-'+suffix+'.H'

            #Call the cmd
            make_cmd = exe + ' adj=y imgsign=1 ' + 'data='+data + ' modl='+output + ' hess='+hess \
                + ' mask='+mask + ' niter='+niter + ' eps='+eps + ' Rm='+Rm + ' reglar='+reg + ' ' + ' norm_dat=l2 norm_mod=hybrid ' + ' resd='+resd + ' & '

            do_computation(make_cmd)
            
            #Do the forward modeling Hm, to see how much it matches the data
            cmd = exe + ' adj=n ' + ' data='+recov_d + ' modl='+output + ' hess='+hess 
            do_figures(cmd)

            output_list.append(output)
            #Generate the figures
            fig = O+'/syn-inv-'+suffix+'.v'

            disp_cmd = '< '+output + ' Window3d | Add scale=-1 | Transp | ' +  'Grey' + '  '+clip + ' wantscalebar=1 title='+\
                output +' ' + '>/dev/null' + ' ' + 'out=inv_res.v' + ' '\
                + label
            do_figures(disp_cmd)

            #Input data
            disp_cmd = '< '+data + ' Window3d | Add scale=-1 | Transp | ' +  'Grey' + '  '+clip + ' wantscalebar=1 title='+\
                data +' ' + '>/dev/null' + ' ' + 'out=data.v' + ' '\
                + label
            do_figures(disp_cmd)
            
            disp_cmd = '< '+recov_d + ' Window3d | Add scale=-1 | Transp | ' +  'Grey' + '  '+clip + ' wantscalebar=1 title='+\
                recov_d +' ' + '>/dev/null' + ' ' + 'out=recov_d.v' + ' '\
                + label
            do_figures(disp_cmd)
            
            
            #data residue 
            disp_cmd = '< '+resd + ' Window3d | Add scale=-1 | Transp | ' +  'Grey' + '  '+clip + ' wantscalebar=1 title='+\
                resd +' ' + '>/dev/null' + ' ' + 'out=resd.v' + ' '\
                + label
            do_figures(disp_cmd)
            
            #disp_cmd = 'vp_SideBySideAniso ' + ' inv_res.v recov_d.v resd.v' + ' > ' + fig
            disp_cmd = 'vppen vpstyle=n gridnum=2,2 ' + ' data.v inv_res.v recov_d.v resd.v' + ' > ' + fig
            do_figures(disp_cmd)

            figlist.append(fig)
            
    #We form the movie
    final_fig_name = 'fig/syn-inv-Rm-'+tag_str+'.v3'
    cmd = 'vp_Movie ' + ' '.join(figlist) + ' ' +'> ' + final_fig_name
    do_figures(cmd)
    cmd = 'tube ' + final_fig_name + ' &'
    do_figures(cmd)


# Hessian Inversion in traditional L2 style
if (sys.argv[1] == '22'):
    B = 'bin'
    exe = B+'/Hesconv_hb_Rm.x'  #The Executive is different 

    #Use l2, so this is a dumb parameter
    Rm_hb = ['0.01']
    #eps_hb  = ['1e-8','1e-7', '1e-6', '1e-5']
    eps_hb  = ['1e-7','1e-1']
    reg = '1'  # Damping regularization

    #${BINDIR}/hesconv.x adj=y imgsign=1 data=wem.sigsb2a.syn.data.lab.H modl=$@ hess=wem.sigsb2a.hess.random.fsec.all.lab.H \
    #mask=wem.sigsb2a.mask.lab.H mmov=wem.sigsb2a.syn.inv.mmov.lab.H rmov=wem.sigsb2a.syn.inv.rmov.lab.H niter=50 eps=0.0002 reglar=2

    O = './scr'
    n_eps  = len(eps_hb)
    reg='1'
    tag_str='damp-l2-'

    figlist=[]
    for ind_eps in range(0, n_eps):
        eps = eps_hb[ind_eps]
        output_list = []
        suffix = tag_str+'eps-'+eps
        output = O+'/syn-inv-'+suffix+'.H'
        
        recov_d = O+'/recov-'+suffix+'.H'
        resd = O +'/resd-'+suffix+'.H'

        #Call the cmd
        make_cmd = exe + ' adj=y imgsign=1 ' + 'data='+data + ' modl='+output + ' hess='+hess \
            + ' mask='+mask + ' niter='+niter + ' eps='+eps + ' reglar='+reg + ' ' + ' norm_dat=l2 norm_mod=l2 ' + ' resd='+resd

        do_computation(make_cmd)
            
        #Do the forward modeling Hm, to see how much it matches the data
        cmd = exe + ' adj=n ' + ' data='+recov_d + ' modl='+output + ' hess='+hess 
        do_figures(cmd)

        output_list.append(output)
        #Generate the figures
        fig = O+'/syn-inv-'+suffix+'.v'
        disp_cmd = '< '+output + ' Window3d | Add scale=-1 | Transp | ' +  'Grey' + '  '+clip + ' wantscalebar=1 title='+\
            output +' ' + '>/dev/null' + ' ' + 'out=inv_res.v' + ' '\
            + label
        do_figures(disp_cmd)

        #Input data
        disp_cmd = '< '+data + ' Window3d | Add scale=-1 | Transp | ' +  'Grey' + '  '+clip + ' wantscalebar=1 title='+\
            data +' ' + '>/dev/null' + ' ' + 'out=data.v' + ' '\
            + label
        do_figures(disp_cmd)

        disp_cmd = '< '+recov_d + ' Window3d | Add scale=-1 | Transp | ' +  'Grey' + '  '+clip + ' wantscalebar=1 title='+\
            recov_d +' ' + '>/dev/null' + ' ' + 'out=recov_d.v' + ' '\
            + label
        do_figures(disp_cmd)
            
        #data residue 
        disp_cmd = '< '+resd + ' Window3d | Add scale=-1 | Transp | ' +  'Grey' + '  '+clip + ' wantscalebar=1 title='+\
            resd +' ' + '>/dev/null' + ' ' + 'out=resd.v' + ' '\
            + label
        do_figures(disp_cmd)
            
        #disp_cmd = 'vp_SideBySideAniso ' + ' inv_res.v recov_d.v resd.v' + ' > ' + fig
        disp_cmd = 'vppen vpstyle=n gridnum=2,2 ' + ' data.v inv_res.v recov_d.v resd.v' + ' > ' + fig
        do_figures(disp_cmd)
        figlist.append(fig)

    #We form the movie
    final_fig_name = 'fig/syn-inv-Rm-'+tag_str+'.v3'
    cmd = 'vp_Movie ' + ' '.join(figlist) + ' ' +'> ' + final_fig_name
    do_figures(cmd)
    cmd = 'tube ' + final_fig_name + ' &'
    do_figures(cmd)

#Invert using the real migrated image
data = 'sigsb2a.imag.fsec.all.H'

if (sys.argv[1] == '3'):
    B = 'bin'
    exe = B+'/Hesconv_hb_Rm.x'  #The Executive is different 

    Rm_hb = ['0.01']
    eps_hb  = ['1e-5','1e-4','5e-4', '1e-3']

    #${BINDIR}/hesconv.x adj=y imgsign=1 data=wem.sigsb2a.syn.data.lab.H modl=$@ hess=wem.sigsb2a.hess.random.fsec.all.lab.H \
    #         mask=wem.sigsb2a.mask.lab.H mmov=wem.sigsb2a.syn.inv.mmov.lab.H rmov=wem.sigsb2a.syn.inv.rmov.lab.H niter=50 eps=0.0002 reglar=2

    O = './scr'

    n_Rm = len(Rm_hb)
    n_eps  = len(eps_hb)

    reg='1'
    tag_str='inv-damp-'

    figlist=[]
    for ind_Rm in range(0,n_Rm):
        Rm = Rm_hb[ind_Rm]
        for ind_eps in range(0, n_eps):
            eps = eps_hb[ind_eps]
            
            output_list = []
            suffix = tag_str+'Rm-'+Rm+'-eps-'+eps
            output = O+'/'+suffix+'.H'
            
            recov_d = O+'/recov-'+suffix+'.H'
            resd = O +'/resd-'+suffix+'.H'

            #Call the cmd
            make_cmd = exe + ' adj=y imgsign=1 ' + 'data='+data + ' modl='+output + ' hess='+hess \
                + ' mask='+mask + ' niter='+niter + ' eps='+eps + ' Rm='+Rm + ' reglar='+reg + ' ' + ' norm_dat=l2 norm_mod=hybrid ' + ' resd='+resd + ' & '

            do_computation(make_cmd)
            
            #Do the forward modeling Hm, to see how much it matches the data
            cmd = exe + ' adj=n ' + ' data='+recov_d + ' modl='+output + ' hess='+hess 
            do_figures(cmd)

            output_list.append(output)
            #Generate the figures
            fig = O+'/syn-inv-'+suffix+'.v'

            disp_cmd = '< '+output + ' Window3d | Add scale=-1 | Transp | ' +  'Grey' + '  '+clip + ' wantscalebar=1 title='+\
                output +' ' + '>/dev/null' + ' ' + 'out=inv_res.v' + ' '\
                + label
            do_figures(disp_cmd)

            #Input data
            disp_cmd = '< '+data + ' Window3d | Add scale=-1 | Transp | ' +  'Grey' + '  '+clip + ' wantscalebar=1 title='+\
                data +' ' + '>/dev/null' + ' ' + 'out=data.v' + ' '\
                + label
            do_figures(disp_cmd)
            
            disp_cmd = '< '+recov_d + ' Window3d | Add scale=-1 | Transp | ' +  'Grey' + '  '+clip + ' wantscalebar=1 title='+\
                recov_d +' ' + '>/dev/null' + ' ' + 'out=recov_d.v' + ' '\
                + label
            do_figures(disp_cmd)
            
            
            #data residue 
            disp_cmd = '< '+resd + ' Window3d | Add scale=-1 | Transp | ' +  'Grey' + '  '+clip + ' wantscalebar=1 title='+\
                resd +' ' + '>/dev/null' + ' ' + 'out=resd.v' + ' '\
                + label
            do_figures(disp_cmd)
            
            #disp_cmd = 'vp_SideBySideAniso ' + ' inv_res.v recov_d.v resd.v' + ' > ' + fig
            disp_cmd = 'vppen vpstyle=n gridnum=2,2 ' + ' data.v inv_res.v recov_d.v resd.v' + ' > ' + fig
            do_figures(disp_cmd)

            figlist.append(fig)
            
    #We form the movie
    final_fig_name = 'fig/inv-hb-'+tag_str+'.v3'
    cmd = 'vp_Movie ' + ' '.join(figlist) + ' ' +'> ' + final_fig_name
    do_figures(cmd)
    cmd = 'tube ' + final_fig_name + ' &'
    do_figures(cmd)

#hb on model residue, qntile m

if (sys.argv[1] == '4'):
    B = 'bin'
    exe = B+'/Hesconv_hb.x'

    qntm_hb = ['0.8','0.9']
    
    #eps_hb  = ['1e-7', '1e-6', '1e-5', '1e-4', '1e-3', '1e-2', '1e-1']
    eps_hb = ['1e-7','1e-5','1e-4','2e-4','4e-4'];

    reg = '1'  # Damping regularization

    #${BINDIR}/hesconv.x adj=y imgsign=1 data=wem.sigsb2a.syn.data.lab.H modl=$@ hess=wem.sigsb2a.hess.random.fsec.all.lab.H \
    #         mask=wem.sigsb2a.mask.lab.H mmov=wem.sigsb2a.syn.inv.mmov.lab.H rmov=wem.sigsb2a.syn.inv.rmov.lab.H niter=50 eps=0.0002 reglar=2

    O = './scr'
 
    n_qntm = len(qntm_hb)
    n_eps  = len(eps_hb)

    reg='1'
    tag_str='mig-damp-'

    figlist=[]
    for ind_qntm in range(0,n_qntm):
        qntm = qntm_hb[ind_qntm]
        for ind_eps in range(0, n_eps):
            eps = eps_hb[ind_eps]
            
            output_list = []
            suffix = tag_str+'qntm-'+qntm+'-eps-'+eps
            output = O+'/result-inv-'+suffix+'.H'
            
            recov_d = O+'/recov-'+suffix+'.H'
            resd = O +'/resd-'+suffix+'.H'

            #Call the cmd
            make_cmd = exe + ' adj=y imgsign=1 ' + 'data='+data + ' modl='+output + ' hess='+hess \
                + ' mask='+mask + ' niter='+niter + ' eps='+eps + ' qntm='+qntm + ' reglar='+reg + ' ' + ' norm_dat=l2 norm_mod=hybrid ' + ' resd='+resd + ' qt_period='+qt_period + ' & '

            do_computation(make_cmd)
            
            #Do the forward modeling Hm, to see how much it matches the data
            cmd = exe + ' adj=n ' + ' data='+recov_d + ' modl='+output + ' hess='+hess 
            do_figures(cmd)

            output_list.append(output)
            #Generate the figures
            fig = O+'/inv-'+suffix+'.v'

            fig1 = ch_ext(output,'v')
            disp_cmd = '< '+output + ' Window3d | Add scale=-1 | Transp | ' +  'Grey' + '  '+clip + ' wantscalebar=1 title='+\
                output +' ' + '>/dev/null' + ' ' + 'out='+fig1 + ' '\
                + label
            do_figures(disp_cmd)

            #Input data
            fig2 = ch_ext(data,'v')
            disp_cmd = '< '+data + ' Window3d | Add scale=-1 | Transp | ' +  'Grey' + '  '+clip + ' wantscalebar=1 title='+\
                data +' ' + '>/dev/null' + ' ' + 'out='+fig2 + ' '\
                + label
            do_figures(disp_cmd)
            
            fig3 = ch_ext(recov_d,'v')
            disp_cmd = '< '+recov_d + ' Window3d | Add scale=-1 | Transp | ' +  'Grey' + '  '+clip + ' wantscalebar=1 title='+\
                recov_d +' ' + '>/dev/null' + ' ' + 'out='+fig3 + ' '\
                + label
            do_figures(disp_cmd)
            
            
            #data residue 
            fig4 = ch_ext(resd,'v')
            disp_cmd = '< '+resd + ' Window3d | Add scale=-1 | Transp | ' +  'Grey' + '  '+clip + ' wantscalebar=1 title='+\
                resd +' ' + '>/dev/null' + ' ' + 'out='+fig4 + ' '\
                + label
            do_figures(disp_cmd)
            
            #disp_cmd = 'vp_SideBySideAniso ' + ' inv_res.v recov_d.v resd.v' + ' > ' + fig
            disp_cmd = 'vppen vpstyle=n gridnum=2,2 ' + fig1 +' ' + fig2 + ' ' + fig3 + ' ' + fig4 + ' > ' + fig
            do_figures(disp_cmd)

            figlist.append(fig)
            
    #We form the movie
    final_fig_name = 'fig/mig-inv-qntm'+tag_str+'.v3'
    cmd = 'vp_Movie ' + ' '.join(figlist) + ' ' +'> ' + final_fig_name
    do_figures(cmd)
    cmd = 'tube ' + final_fig_name + ' &'
    do_figures(cmd)

#hb on both data and model residue, qntile md

if (sys.argv[1] == '5'):
    B = 'bin'
    exe = B+'/Hesconv_hb.x'

    qntm_hb = ['0.8','0.9', '1.0']
    qntd = '0.85'
    #eps_hb  = ['1e-7', '1e-6', '1e-5', '1e-4', '1e-3', '1e-2', '1e-1']
    eps_hb = [ '1e-5', '1e-3','1e-1','1','10']#, '1e-4','2e-4','5e-4','1e-3' ]

    reg = '1'  # Damping regularization

    #${BINDIR}/hesconv.x adj=y imgsign=1 data=wem.sigsb2a.syn.data.lab.H modl=$@ hess=wem.sigsb2a.hess.random.fsec.all.lab.H \
    #         mask=wem.sigsb2a.mask.lab.H mmov=wem.sigsb2a.syn.inv.mmov.lab.H rmov=wem.sigsb2a.syn.inv.rmov.lab.H niter=50 eps=0.0002 reglar=2

    O = './scr'
 
    n_qntm = len(qntm_hb)
    n_eps  = len(eps_hb)

    reg='1'
    tag_str='mig-damp-qntd-'+qntd+'-'

    figlist=[]
    for ind_qntm in range(0,n_qntm):
        qntm = qntm_hb[ind_qntm]
        for ind_eps in range(0, n_eps):
            eps = eps_hb[ind_eps]
            
            output_list = []
            suffix = tag_str+'qntm-'+qntm+'-eps-'+eps
            output = O+'/inv-'+suffix+'.H'
            
            recov_d = O+'/recov-'+suffix+'.H'
            resd = O +'/resd-'+suffix+'.H'

            #Call the cmd
            make_cmd = exe + ' adj=y imgsign=1 ' + 'data='+data + ' modl='+output + ' hess='+hess \
                + ' mask='+mask + ' niter='+niter + ' eps='+eps + ' qntm='+qntm + ' qntd='+qntd +' reglar='+reg + ' ' + ' norm_dat=hybrid norm_mod=hybrid ' + ' resd='+resd + ' qt_period='+qt_period + ' & '

            do_computation(make_cmd)
            
            #Do the forward modeling Hm, to see how much it matches the data
            cmd = exe + ' adj=n ' + ' data='+recov_d + ' modl='+output + ' hess='+hess 
            do_figures(cmd)

            output_list.append(output)
            #Generate the figures
            fig = O+'/mig-inv-'+suffix+'.v'

            disp_cmd = '< '+output + ' Window3d | Add scale=-1 | Transp | ' +  'Grey' + '  '+clip + ' wantscalebar=1 title='+\
                output +' ' + '>/dev/null' + ' ' + 'out=inv_res.v' + ' '\
                + label
            do_figures(disp_cmd)

            #Input data
            disp_cmd = '< '+data + ' Window3d | Add scale=-1 | Transp | ' +  'Grey' + '  '+clip + ' wantscalebar=1 title='+\
                data +' ' + '>/dev/null' + ' ' + 'out=data.v' + ' '\
                + label
            do_figures(disp_cmd)
            
            disp_cmd = '< '+recov_d + ' Window3d | Add scale=-1 | Transp | ' +  'Grey' + '  '+clip + ' wantscalebar=1 title='+\
                recov_d +' ' + '>/dev/null' + ' ' + 'out=recov_d.v' + ' '\
                + label
            do_figures(disp_cmd)
            
            
            #data residue 
            disp_cmd = '< '+resd + ' Window3d | Add scale=-1 | Transp | ' +  'Grey' + '  '+clip + ' wantscalebar=1 title='+\
                resd +' ' + '>/dev/null' + ' ' + 'out=resd.v' + ' '\
                + label
            do_figures(disp_cmd)
            
            #disp_cmd = 'vp_SideBySideAniso ' + ' inv_res.v recov_d.v resd.v' + ' > ' + fig
            disp_cmd = 'vppen vpstyle=n gridnum=2,2 ' + ' data.v inv_res.v recov_d.v resd.v' + ' > ' + fig
            do_figures(disp_cmd)

            figlist.append(fig)
            
    #We form the movie
    final_fig_name = 'fig/mig-inv-qntmd'+tag_str+'.v3'
    cmd = 'vp_Movie ' + ' '.join(figlist) + ' ' +'> ' + final_fig_name
    do_figures(cmd)
    cmd = 'tube ' + final_fig_name + ' &'
    do_figures(cmd)

